#include <iostream>
using namespace std;
void unesi(int** a, int n)
{
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            cin >> a[i][j];
        }
    }
}
int pravougaonik(int** a, int i, int j, int m, int n)
{
    int c=i, b=j;
    while(c<n-1 && a[c][j]==a[c+1][j])
        c++;
    while(b<n-1 && a[i][b]==a[i][b+1])
        b++;;
    int k=i, l=j;
    while(k<c)
    {
        while(l<b)
        {
            if(a[k][l]!=m)
               {
                return 0;
               }
            l++;
        }
        k++;
        l=j;
    }
    k=0;
    l=0;
    while(k<i)
    {
        while(l<n)
        {
            if(a[k][l]==m)
                {
                    return 0;
                }
            l++;
        }
        k++;
        l=0;
    }
    k=c+1;
    l=0;
    while(k<n)
    {
        while(l<n)
        {
            if(a[k][l]==m)
            {
                return 0;
            }
            l++;
        }
        k++;
        l=0;
    }
    k=0;
    l=0;
    while(k<n)
    {
        while(l<j)
        {
            if(a[k][l]==m)
                return 0;
            l++;
        }
        k++;
        l=0;
    }
    k=0;
    l=b+1;

    while(k<n)
    {
        while(l<n)
        {
            if(a[k][l]==m)
               {
                  return 0;
               }
            l++;
        }
        k++;
        l=b+1;
    }
    return 1;
}

int main()
{
    int n, k;
    cin >> n >> k;
    int** a=new int*[n];
    for(int i=0; i<n; i++)
    {
        a[i]=new int[n];
    }
    unesi(a, n);
    int b=0;
    for(int m=1; m<=k; m++)
    {
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<n; j++)
            {
                if(a[i][j]==m)
                {
                    if(pravougaonik(a, i, j, m, n))
                    {
                        cout <<endl << i << j << endl;
                       b++;
                    }
                    m++;
                    i=0;
                    j=0;
                }
            }
        }
    }


    cout << b;
    return 0;
}